<?php

@header("Content-type: text/html; charset=UTF-8");

/**
* @version 1.0.0
* @package RSMembership! Pas 1.0.1
* @copyright softiran.org 2016
* @url  http://softiran.org
* @email  Info@softiran.org
*/
defined('_JEXEC') or die('Restricted access');

if (file_exists(JPATH_ADMINISTRATOR.'/components/com_rsmembership/helpers/rsmembership.php')) {
    require_once JPATH_ADMINISTRATOR.'/components/com_rsmembership/helpers/rsmembership.php';
    
require_once JPATH_PLUGINS.'/system/rsmembershippas/paslibs/paslibs.php';
}
class plgSystemRSMembershipPas extends JPlugin
{
    
   public function __construct(&$subject, $config)
    {
        
        parent::__construct($subject, $config);
        
        if ($this->canRun() && $this->params) {
            $this->_loadLanguage();
            $name = $this->params->get('payment_name', 'Pas');
            RSMembership::addPlugin($this->getTranslation($name), 'rsmembershippas'); 
        }
    }
    
    protected function getTranslation($text) {
        $lang = JFactory::getLanguage();
        $key  = str_replace(' ', '_', $text);
        if ($lang->hasKey($key)) {
            return JText::_($key);
        } else {
            return $text;
        }
    }
    protected function _loadLanguage() {
        $this->loadLanguage('plg_system_rsmembership', JPATH_ADMINISTRATOR);
        $this->loadLanguage('plg_system_rsmembershippas', JPATH_ADMINISTRATOR);
    }
    function canRun()
    {
      return file_exists(JPATH_ADMINISTRATOR.'/components/com_rsmembership/helpers/rsmembership.php');
    }

    function plgSystemRSMembershipPas(&$subject, $config)
    {
        parent::__construct($subject, $config);
        if (!$this->canRun()) return;
        $this->_plugin =& JPluginHelper::getPlugin('system', 'rsmembershippas');
        $this->_params = json_decode($this->_plugin->params);
        RSMembership::addPlugin('Pas', 'rsmembershippas');
    }
	
	public function onAfterDispatch()
    {
        $app = JFactory::getApplication();
        if ($app->input->getBoolean('paspayment')) {
            $this->onPaymentNotification($app);
        }
    }
	
	private function CurrencyAmount($amount)
    {
        $currency = $this->params->get('currency');
        if ($currency) 
		{ 
            $amount *= 10;
        }
        return $amount;
    }
	
    function onMembershipPayment($plugin, $data, $extra, $membership, $transaction,$html)
    {
        if (!$this->canRun()) return;
        if ($plugin != 'rsmembershippas') return false;
		
		
        $mid = '';
		$terminal = $this->params->get('sahkey'); 
		$extra_total = 0;
            foreach ($extra as $row) {
                $extra_total += $row->price;
            }

        $amount = $this->CurrencyAmount($transaction->price + $extra_total);
		 
        $amount = number_format($amount,0);
        $amount = str_replace(',','',$amount);
        $transaction->custom = time(); /// set orderId
        $callBackUrl = JRoute::_(JURI::base().'index.php?option=com_rsmembership&paspayment=1&custom='.$transaction->custom);
        $html = "";
		$session =& JFactory::getSession();
		$session->set('membership_id', $membership->id);
	  
        $html .= pasClass::setPas($amount,$mid,$terminal,$callBackUrl);
        
        
      return $html;  


   }
   
  public function onPaymentNotification($app)
    {
        @header('Content-Type: text/html; charset=utf-8');
        $session =& JFactory::getSession();
        if (!$this->canRun()){
            echo ('خطایی در اجرای پلاگین رخ داده است');
        }else{

            $transaction_custom = JRequest::getVar('custom');
            $mid = $this->params->get('sahkey'); 

			$db = JFactory::getDbo();
			$query = $db->getQuery(true);
			$query->select('*')
				->from($db->quoteName('#__rsmembership_transactions'))
				->where($db->quoteName('status') . ' != ' . $db->quote('completed'))
				->where($db->quoteName('custom') . ' = ' . $db->quote($transaction_custom));
			$db->setQuery($query);
			$transaction = @$db->loadObject();
               
            if($transaction)
			{ 
                  
				if( isset($_POST['respcode']) && $_POST['respcode'] == '0' )
				{
					
					$db = JFactory::getDbo();
					$query = $db->getQuery(true);
					 $query->select(array('COUNT(*)'))->from($db->quoteName('#__rsmembership_transactions'))
					 ->where($db->quoteName('hash') . ' LIKE '. $db->quote('%'.$_POST['digitalreceipt'].'%'));
					$db->setQuery($query);
					$results = $db->loadResult();

					if($results == 0)
					{
						 $result = pasClass::getPas($_POST,$mid); 
					}else
					{
						$result[0] = 0;
						$result[1] = 'رسید قبلا استفاده شده است';
					}
				}
				else
				{
					$result[0] = 0;
					$result[1] = $_POST['respmsg'];
				}

                if($result[0])
				{
					$RefID = $result[2];
					$query->clear();
					$query->update($db->quoteName('#__rsmembership_transactions'))
						->set($db->quoteName('hash') . ' = ' . $db->quote($RefID))
						->where($db->quoteName('id') . ' = ' . $db->quote($transaction->id));

					$db->setQuery($query);
					$db->execute();

					$membership_id = $session->get('membership_id');

					if (!$membership_id)
						throw new Exception('membership_not_found');

					$query->clear()
						->select('activation')
						->from($db->quoteName('#__rsmembership_memberships'))
						->where($db->quoteName('id') . ' = ' . $db->quote((int)$membership_id));
					$db->setQuery($query);
					$activation = $db->loadResult();

					if ($activation)
					{
						RSMembership::approve($transaction->id);
					}
					
					$message = 'پرداخت شما موفق بود . کد پیگیری شما :'.$RefID;
					$app->redirect(JRoute::_(JURI::base() . 'index.php?option=com_rsmembership&view=mymemberships', false), $message, 'message');
                    exit;die;
                    
                }else
				{
					$message = $result[1];
					$app->enqueueMessage($message, 'warning'); 
                }
            
            }else
			{
                $message = 'سفارش شما معتبر نیست و تراکنش شما لغو شده است';
				$app->enqueueMessage($message, 'warning');   
            }

    }

 }
 
}